Subject: Can any_value be used like first_value in an aggregate?

From: Bruno Wolff III <[email-masked]>
Date: Tue, 25 Jun 2024 11:42:08 -0500

For example, is output of 10 guaranteed in the following:
bruno=> select any_value(x order by x desc) from generate_series(1,10) as x;
 any_value 
-----------
        10
(1 row)

The use case is that I want to return a value of one column that is paired 
with the maximum value of another column in each group when using GROUP BY.

(There aren't going to be any NULLs in the involved columns.)

Thanks.

---

From: Tom Lane <[email-masked]>
Date: Tue, 25 Jun 2024 13:08:45 -0400

> bruno=> select any_value(x order by x desc) from generate_series(1,10) as x;

Not really.  It will work that way in simple cases, but I think the
behavior stops being predictable if the input gets large enough to
induce the planner to use parallel aggregation.  In any case, the
example shown isn't amazingly efficient since it'll still perform
a sort to meet the ORDER BY spec.

> with the maximum value of another column in each group when using GROUP BY.

Use window functions (i.e. first_value).  This is what they're for,
and they are smart enough to do just one sort for functions sharing
a common window spec.

			regards, tom lane

---

From: Bruno Wolff III <[email-masked]>
Date: Tue, 25 Jun 2024 14:11:57 -0500

On Tue, Jun 25, 2024 at 13:08:45 -0400,

Thanks.

>and they are smart enough to do just one sort for functions sharing

If I do that, I'd need to do it as a subselect inside of a group by. I'm 
thinking distinct on may work and be a better way to do it. The actual 
use case is a set of tripplets returned from a query, where I want on 
row for each distinct value in the first column, paired with the value 
in the second column, for which the third column is the largest. The 
second and third columns are effectively dependent on each other, so there 
won't be any ambiguity.

Thanks for getting me thinking about some other ways to approach the problem.

---

From: Laurenz Albe <[email-masked]>
Date: Wed, 26 Jun 2024 09:50:59 +0200

On Tue, 2024-06-25 at 14:11 -0500, Bruno Wolff III wrote:
> The actual 

Try

  SELECT DISTINCT ON (first_column)
         first_column,
         second_column,
         third_column
  FROM the_table
  ORDER BY first_column, third_column DESC;

Yours,
Laurenz Albe